//    case 110:
// Процесс дистилляции с подключаемым дефлегматором
// Процесс поддерживат температуру в дефлегматоре не более заданной + дельта и не менее заданной - дельта
void ProcessDistilDefl()
{

  // Если достигнут уровень в приемной емкости или температуре в кубе превысыла допустимую температуру для этого режима

  if ((flAlarmUroven || temps[TEMP_KUB]>=tEndDistDefl || deltaPower>=Power) && StateMachine<7) 
  { // Переводим автомат в стадию завершения 
    StateMachine=7;        
    SecondsEnd=2*60+((int)(FlAvtonom>>1))*60;// Через одну минуту отключим воду
    SecTempPrev=Seconds;
    if (BeepStateProcess) my_beep(BEEP_LONG);
  }
  // Проверяем температуру в ТСА
  if (temps[TEMP_TSA]>=MAX_TEMP_TSA) 
  {
    StateMachine=101; // Переводим автомат в состояние аварии по ТСА.
    UstPower=0;
  }
  if (flAlarmMPX5010) StateMachine=100; // Переводим в режим тревоги по датчику давления
  
  switch  (StateMachine)
  {
  case 0: // Процесс не запущен
    break;
  case 1: // Начало процесса
    PrepareProcess();
    //          if (FlToGSM && lastSMSState!=StateMachine) StateToSMS();
    lastSMSState=0;
    KlOpen[KLP_VODA]=PER_KLP_OPEN;
    KlClose[KLP_VODA]=PER_KLP_CLOSE;
    StateMachine=2;//Этот процесс пока заблокирован, сразу идем на окончание.
//    digitalWrite(PIN_REG_ON,HIGH);
    digitalWrite(PIN_RZG_ON,RELAY_HIGH);
    digitalWrite(PIN_ALL_OFF,!ALL_OFF_HIGH);
    digitalWrite(PIN_START_1,RELAY_HIGH);
    digitalWrite(PIN_START_2,RELAY_HIGH);
    flAllOff=0;
    if (BeepStateProcess) my_beep(BEEP_LONG);
    deltaPower=0;
  case 2: // Ожидание, пока прогреется термометр в дефлегматоре

    UstPower=Power; // Устанавливаем максимальную мощность для разгона

    // Если температура в дефлегматоре меньше 70 градусов и датчик дефлегматора в принципе подключен, тогда ждем, пока
    // дефлегматор прогреется, чтобы запустить воду в холодильник (это для некоторой экономии воды)
    if (temps[TEMP_DEFL]<TempDeflBegDistil && ds1820_devices>1 || (TempDeflBegDistil<0 &&  temps[TEMP_KUB]<-TempDeflBegDistil) ) break;

    // Подаем питание на клапан подачи воды холодильника
    StateMachine=3;        
    if (BeepStateProcess) my_beep(BEEP_LONG);

  case 3:
    // Ждем, пока температура в кубе не достигнет температуры начала дистилляции (если есть датчик дефлегматора, тогда этот пункт сразу
    // проскочится, поскольку темперетура в кубе не может быть меньше, чем температура в дефлегматоре
    if (temps[TEMP_KUB]<TempDeflBegDistil) break;
    // Подаем питание на клапан подачи воды холодильника

    // Подаем питание на клапан подачи воды холодильника
    // для этого синхронизируем его с клапаном общей подачи воды (возможно, при этом будет меньше гидроударов, хотя я их и так не наблюдаю)
    KlOpen[KLP_HLD]=KlOpen[KLP_VODA];
    KlClose[KLP_HLD]=KlClose[KLP_VODA];
    KlState[KLP_HLD]=KlState[KLP_VODA];
    KlCount[KLP_HLD]=KlCount[KLP_VODA];

    StateMachine=4;     
    time2=15*60; // Взводиим таймер на 15 минут   
    if (BeepStateProcess) my_beep(BEEP_LONG);
    digitalWrite(PIN_RZG_ON,!RELAY_HIGH);

  case 4: // Дефлегматор отключен.
    // Если более 10 минут не вышли за пределы температуры, тогда увеличиваем мощность.
    if (time2==0)
    {
      deltaPower=deltaPower-(int) (PowerDistil/20);
      if (deltaPower<0) deltaPower=0;
      time2=10*60;
    }

    UstPower=PowerDistil-deltaPower; // Устанавливаем мощность дистилляции.

    if (temps[TEMP_DEFL]>TempDefl)
    {  
      // Включаем дефлегматор и холодильник
      
      KlOpen[KLP_DEFL_D]=KlOpen[KLP_VODA];
      KlClose[KLP_DEFL_D]=KlClose[KLP_VODA];
      KlState[KLP_DEFL_D]=KlState[KLP_VODA];
      KlCount[KLP_DEFL_D]=KlCount[KLP_VODA];
      
      KlOpen[KLP_HLD]=KlOpen[KLP_VODA];
      KlClose[KLP_HLD]=KlClose[KLP_VODA];
      KlState[KLP_HLD]=KlState[KLP_VODA];
      KlCount[KLP_HLD]=KlCount[KLP_VODA];
      StateMachine=5; // Переходим к этапу поддержания температуры путем частичной подачи воды в дефлегмато
      if (BeepStateProcess) my_beep(BEEP_LONG);
    }
    else    
      break;    

  case 5:// 50% воды из холодильника идет в дефлегматор.
    // Если более 10 минут не вышли за пределы температуры, тогда увеличиваем мощность.
    time2=10*60;
    if (time3==0)
    {
      deltaPower=deltaPower-(int) (PowerDistil/30);
      if (deltaPower<0) deltaPower=0;
      time3=10*60;
    }
    UstPower=PowerDistil-deltaPower; // Устанавливаем мощность дистилляции.
    // Если температура превысила температуру, которую надо поддерживать в дефлегматоре+дельта, тогда переходим к режиму, когда
    // вся вода из холодильника идет через дефлегматор
    if (temps[TEMP_DEFL]>TempDefl+DeltaDefl)
    {  
      // Отключаем прямой выход из холодильника
      KlOpen[KLP_HLD]=0;
      KlClose[KLP_HLD]=10;
      // Включаем дефлегматор
      KlOpen[KLP_DEFL_D]=KlOpen[KLP_VODA];
      KlClose[KLP_DEFL_D]=KlClose[KLP_VODA];
      KlState[KLP_DEFL_D]=KlState[KLP_VODA];
      KlCount[KLP_DEFL_D]=KlCount[KLP_VODA];

      StateMachine=6; // Переходим к этапу поддержания температуры путем 100% направления воды в дефлегматор        
      time1=0;
      if (BeepStateProcess) my_beep(BEEP_LONG);
    }
    else
      if (temps[TEMP_DEFL]<TempDefl-DeltaDefl) // Если в результате работы с 50% дефлегматором, температура понизилась переходим в режим работы без дефлегматора
      {
        
        KlOpen[KLP_DEFL_D]=0;
        KlClose[KLP_DEFL_D]=10;
        
        KlOpen[KLP_HLD]=KlOpen[KLP_VODA];
        KlClose[KLP_HLD]=KlClose[KLP_VODA];
        KlState[KLP_HLD]=KlState[KLP_VODA];
        KlCount[KLP_HLD]=KlCount[KLP_VODA];
        StateMachine=4; // Переходим к этапу без дефлегмации
        if (BeepStateProcess) my_beep(BEEP_LONG);
        break;
      }
      else    
        break;

  case 6: // Вся вода из холодильника идет в дефлегматор.
    // Взводиим таймер на 10 минут
    time3=10*60;
    UstPower=PowerDistil-deltaPower; // Устанавливаем мощность дистилляции.
    // Если температура превысила требуемую + дельта более, чем на полдельта за три минуты, тогда уменьшааем мощность 
    if (temps[TEMP_DEFL]>TempDefl+DeltaDefl+DeltaDefl/2)
    {
      if (time1==0)
      {
        deltaPower=deltaPower+(int) (PowerDistil/10);
        time1=3*60;// Взводим таймер на три минуты.
      }
    }
    
    if (temps[TEMP_DEFL]<TempDefl) // Если в результате работы с 100% дефлегматором, температура понизилась ниже установленной температуры переходим в режим работы с 50% дефлегма
    {
      // Включаем прямой выход из холодильника.
      KlOpen[KLP_HLD]=KlOpen[KLP_VODA];
      KlClose[KLP_HLD]=KlClose[KLP_VODA];
      KlState[KLP_HLD]=KlState[KLP_VODA];
      KlCount[KLP_HLD]=KlCount[KLP_VODA];
      
      KlOpen[KLP_DEFL_D]=KlOpen[KLP_VODA];
      KlClose[KLP_DEFL_D]=KlClose[KLP_VODA];
      KlState[KLP_DEFL_D]=KlState[KLP_VODA];
      KlCount[KLP_DEFL_D]=KlCount[KLP_VODA];
      StateMachine=5; // Переходим к этапу поддержания температуры 50% дефлегмацией
      time2=15*60; // Взводиим таймер на 15 минут   
      if (BeepStateProcess) my_beep(BEEP_LONG);
      break;
    }
    else    
      break;

  case 7:// Ждем минуту для окончания подачи воды
    UstPower=0;
    digitalWrite(PIN_START_1,!RELAY_HIGH);
    digitalWrite(PIN_START_2,!RELAY_HIGH);

    SecondsEnd=SecondsEnd-(Seconds-SecTempPrev);
    SecTempPrev=Seconds;

    if (SecondsEnd<=0)
    {
      // Переводим автомат в конечное состояние
      StateMachine=100;        
      SecondsEnd=Seconds;
      if (BeepStateProcess) my_beep(BEEP_LONG);
    }
    break;
  case 100:// Конечное состояние автомата
    if (BeepEndProcess) my_beep(BEEP_LONG);
  case 101:
    // Отключаем на всякий случай все!
    if (FlToGSM && lastSMSState!=StateMachine) StateToSMS();
    if (BeepEndProcess) my_beep(BEEP_LONG);
    UstPower=0;
    CloseAllKLP();
//    digitalWrite(PIN_REG_ON,LOW);
    digitalWrite(PIN_RZG_ON,!RELAY_HIGH);
    digitalWrite(PIN_ALL_OFF,ALL_OFF_HIGH);
    digitalWrite(PIN_START_1,!RELAY_HIGH);
    digitalWrite(PIN_START_2,!RELAY_HIGH);
    flAllOff=1;

    break;
  }
}

