//    case 104: //Текущее состояние - первый недробный перегон
//    case 106: //Текущее состояние - второй дробный
//    case 107: //Текущее состояние - третий дробный
//    case 105: //Текущее состояние - отбор голов

// Процесс отбора голов (без дефлегматора)
void ProcessSimpleGlv()
{

  if (flAlarmUroven && StateMachine<4) 
  { // Переводим автомат в стадию завершения 
    StateMachine=4;        
    SecondsEnd=60+((int)(FlAvtonom>>1))*60;// Через одну минуту отключим воду
    SecTempPrev=Seconds;
    if (BeepStateProcess) my_beep(BEEP_LONG);
  }

  
  // Проверяем температуру в ТСА
  if (temps[TEMP_TSA]>=MAX_TEMP_TSA) 
  {
    StateMachine=101; // Переводим автомат в состояние аварии по ТСА.
    UstPower=0;
  }
  if (flAlarmMPX5010) StateMachine=100; // Переводим в режим тревоги по датчику давления
  
  switch  (StateMachine)
  {
  case 0: // Процесс не запущен
    break;
  case 1: // Начало процесса
    PrepareProcess();
    //         if (FlToGSM && lastSMSState!=StateMachine) StateToSMS();
    lastSMSState=0;

    KlOpen[KLP_VODA]=PER_KLP_OPEN;
    KlClose[KLP_VODA]=PER_KLP_CLOSE;
    StateMachine=2;
//    digitalWrite(PIN_REG_ON,HIGH);
    digitalWrite(PIN_RZG_ON,RELAY_HIGH);
    digitalWrite(PIN_ALL_OFF,!ALL_OFF_HIGH);
    digitalWrite(PIN_START_1,RELAY_HIGH);
    digitalWrite(PIN_START_2,RELAY_HIGH);
    flAllOff=0;

    if (BeepStateProcess) my_beep(BEEP_LONG);
  case 2: // Ожидание, пока прогреется термометр в дефлегматоре

    UstPower=Power; // Устанавливаем максимальную мощность для разгона
    // Подчиненные в разгон
    digitalWrite(PIN_SLAVE_0, 1);
    digitalWrite(PIN_SLAVE_1, 0);
    digitalWrite(PIN_SLAVE_2, 0);
    digitalWrite(PIN_SLAVE_3, 0);
    

    // Если температура в дефлегматоре меньше 70 градусов и датчик дефлегматора в принципе подключен, тогда ждем, пока
    // дефлегматор прогреется, чтобы запустить воду в холодильник (это для некоторой экономии воды)
    if (temps[TEMP_DEFL]<TempDeflBegDistil && ds1820_devices>1 || (TempDeflBegDistil<0 &&  temps[TEMP_KUB]<-TempDeflBegDistil)) break;

    // Подаем питание на клапан подачи воды холодильника
    StateMachine=3;        
    if (BeepStateProcess) my_beep(BEEP_LONG);
    // Ждем, пока температура в кубе не достигнет температуры начала дистилляции (если есть датчик дефлегматора, тогда этот пункт сразу
    // проскочится, поскольку темперетура в кубе не может быть меньше, чем температура в дефлегматоре
    //if (temps[TEMP_KUB]<TempDeflBegDistil) break;

    // Подаем питание на клапан подачи воды холодильника
    KlOpen[KLP_HLD]=KlOpen[KLP_VODA];
    KlClose[KLP_HLD]=KlClose[KLP_VODA];
    KlState[KLP_HLD]=KlState[KLP_VODA];
    KlCount[KLP_HLD]=KlCount[KLP_VODA];
    if (BeepStateProcess) my_beep(BEEP_LONG);
    digitalWrite(PIN_RZG_ON,!RELAY_HIGH);
  case 3:// Работа в режиме отбра голов идет исключетельно по наполнению приемной емкости, но все-таки температуру
    // на всякий случай анализируем, ведь температура в кубе при отборе голов, в любом случае не может быть больше, чем температура окончания
    // третьей дробной перегонки

    UstPower=PowerGlvDistil; // Устанавливаем мощность отбора голов.
    // Клапан отбора голов устанавливаем, поскольку по совместительству этот режим может использоваться и для эпюрации
    // Устанавливаем клапан отбора хвостов и голов в соответвии с установленнным ШИМ
    //int tEndRectOtbGlv=854;     // Температура окончания отбора голов 85.4 С
    if (ProcChimOtbGlv>0)
        KlOpen[KLP_GLV_HVS]=(timeChimRectOtbGlv/100)*ProcChimOtbGlv;
    else
        KlOpen[KLP_GLV_HVS]=-ProcChimOtbGlv;
    
    KlClose[KLP_GLV_HVS]=timeChimRectOtbGlv-KlOpen[KLP_GLV_HVS];
    
    // Подчиненные в режим отбора голов
    digitalWrite(PIN_SLAVE_0, 0);
    digitalWrite(PIN_SLAVE_1, 1);
    digitalWrite(PIN_SLAVE_2, 0);
    digitalWrite(PIN_SLAVE_3, 0);

    if (temps[TEMP_KUB]>=Temp3P)
    {  
      StateMachine=4;        
      SecondsEnd=1*60+((int)(FlAvtonom>>1))*60;// Через две минуты отключим воду
      SecTempPrev=Seconds;
      if (BeepStateProcess) my_beep(BEEP_LONG);

    }
    else    
      break;    
  case 4:// Ждем минуту для окончания подачи воды
    UstPower=0;
    // Подчиненные отключаем
    digitalWrite(PIN_SLAVE_0, 0);
    digitalWrite(PIN_SLAVE_1, 0);
    digitalWrite(PIN_SLAVE_2, 0);
    digitalWrite(PIN_SLAVE_3, 0);
    digitalWrite(PIN_START_1,!RELAY_HIGH);
    digitalWrite(PIN_START_2,!RELAY_HIGH);
    
    SecondsEnd=SecondsEnd-(Seconds-SecTempPrev);
    SecTempPrev=Seconds;

    if (SecondsEnd<=0)
    {
      // Переводим автомат в конечное состояние
      StateMachine=100;        
      SecondsEnd=Seconds;
      if (BeepStateProcess) my_beep(BEEP_LONG);
    }
    break;
  case 101: // Превышение температуры в ТСА!!!
    my_beep(3*BEEP_LONG);
  case 100:// Конечное состояние автомата
    // Отключаем на всякий случай все!
    if (FlToGSM && lastSMSState!=StateMachine) StateToSMS();
    if (BeepEndProcess) my_beep(BEEP_LONG);
    UstPower=0;
    // Подчиненные отключаем
    digitalWrite(PIN_SLAVE_0, 0);
    digitalWrite(PIN_SLAVE_1, 0);
    digitalWrite(PIN_SLAVE_2, 0);
    digitalWrite(PIN_SLAVE_3, 0);
    
    CloseAllKLP();
//    digitalWrite(PIN_REG_ON,LOW);
    digitalWrite(PIN_RZG_ON,!RELAY_HIGH);
    digitalWrite(PIN_ALL_OFF,ALL_OFF_HIGH);
    digitalWrite(PIN_START_1,!RELAY_HIGH);
    digitalWrite(PIN_START_2,!RELAY_HIGH);
    flAllOff=1;

    break;
  }
}

void ProcessSimpleDistill()
{

  if (flAlarmUroven && StateMachine<4) 
  { // Переводим автомат в стадию завершения 
    StateMachine=4;        
    SecondsEnd=2*60+((int)(FlAvtonom>>1))*60;// Через две минуты отключим воду
    SecTempPrev=Seconds;
    if (BeepStateProcess) my_beep(BEEP_LONG);
  }

  // Проверяем температуру в ТСА
  if (temps[TEMP_TSA]>=MAX_TEMP_TSA) 
  {
    StateMachine=101; // Переводим автомат в состояние аварии по ТСА.
    UstPower=0;
  }

  if (flAlarmMPX5010) StateMachine=100; // Переводим в режим тревоги по датчику давления
  
// Если первая недробная дистилляция и процесс запущен, тогда включаем мешалку. 
  if (IspReg==104 && StateMachine>0 && StateMachine<=4)
  {
    // Работаем в следующем режиме - 2 минуты пауза, 1 минута работает миксер.
    if (time3==0) 
    {  
       time3=((int) tempP[0]+ (int) timeP[0])*60; // Взводим насос на десять минут работы
       timeMIXER=(int) tempP[0] *60;        
    }    
  }

 
  switch  (StateMachine)
  {
  case 0: // Процесс не запущен
    break;
  case 1: // Начало процесса
    PrepareProcess();
    //          if (FlToGSM && lastSMSState!=StateMachine) StateToSMS();
    lastSMSState=0;

    KlOpen[KLP_VODA]=PER_KLP_OPEN;
    KlClose[KLP_VODA]=PER_KLP_CLOSE;
    StateMachine=2;
    if (BeepStateProcess) my_beep(BEEP_LONG);
//    digitalWrite(PIN_REG_ON,HIGH);
    digitalWrite(PIN_RZG_ON,RELAY_HIGH);
    digitalWrite(PIN_ALL_OFF,!ALL_OFF_HIGH);
    digitalWrite(PIN_START_1,RELAY_HIGH);
    digitalWrite(PIN_START_2,RELAY_HIGH);
    flAllOff=0;

  case 2: // Ожидание, пока прогреется термометр в дефлегматоре

    UstPower=Power; // Устанавливаем максимальную мощность для разгона
    // Подчиненные переводим в разгон
    digitalWrite(PIN_SLAVE_0, 1);
    digitalWrite(PIN_SLAVE_1, 0);
    digitalWrite(PIN_SLAVE_2, 0);
    digitalWrite(PIN_SLAVE_3, 0);

    // Если температура в дефлегматоре меньше 70 градусов и датчик дефлегматора в принципе подключен, тогда ждем, пока
    // дефлегматор прогреется, чтобы запустить воду в холодильник (это для некоторой экономии воды)
    if (temps[TEMP_DEFL]<TempDeflBegDistil && ds1820_devices>1 || (TempDeflBegDistil<0 &&  temps[TEMP_KUB]<-TempDeflBegDistil) ) break;

    // Подаем питание на клапан подачи воды холодильника
    // для этого синхронизируем его с клапаном общей подачи воды (возможно, при этом будет меньше гидроударов, хотя я их и так не наблюдаю)
    KlOpen[KLP_HLD]=KlOpen[KLP_VODA];
    KlClose[KLP_HLD]=KlClose[KLP_VODA];
    KlState[KLP_HLD]=KlState[KLP_VODA];
    KlCount[KLP_HLD]=KlCount[KLP_VODA];
    StateMachine=3;        
    if (BeepStateProcess) my_beep(BEEP_LONG);
    digitalWrite(PIN_RZG_ON,!RELAY_HIGH);

  case 3:// Ждем, пока температура в кубе не превысит установленную
    UstPower=PowerDistil; // Устанавливаем максимальную мощность для разгона
    digitalWrite(PIN_SLAVE_0, 0);
    digitalWrite(PIN_SLAVE_1, 0);
    digitalWrite(PIN_SLAVE_2, 1); // Переводим подчиненный в режим дистилляции
    digitalWrite(PIN_SLAVE_3, 0);

    if (IspReg==104) TekTemp=Temp1P; //Текущее состояние - первый недробный перегон
    if (IspReg==106) TekTemp=Temp2P; //Текущее состояние - второй дробный 
    if (IspReg==107) TekTemp=Temp3P; //Текущее состояние - третий дробный

    if (temps[TEMP_KUB]>=TekTemp)
    {  
      StateMachine=4;        
      SecondsEnd=2*60+((int)(FlAvtonom>>1))*60;// Через две минуты отключим воду
      SecTempPrev=Seconds;
      if (BeepStateProcess) my_beep(BEEP_LONG);
    }
    else    
      break;    
  case 4:// Ждем минуту для окончания подачи воды
    UstPower=0;
    digitalWrite(PIN_START_1,!RELAY_HIGH);
    digitalWrite(PIN_START_2,!RELAY_HIGH);
    
    // Отключаем подчиненные
    digitalWrite(PIN_SLAVE_0, 0);
    digitalWrite(PIN_SLAVE_1, 0);
    digitalWrite(PIN_SLAVE_2, 0); 
    digitalWrite(PIN_SLAVE_3, 0);
    SecondsEnd=SecondsEnd-(Seconds-SecTempPrev);
    SecTempPrev=Seconds;

    if (SecondsEnd<=0)
    {
      // Переводим автомат в конечное состояние
      StateMachine=100;        
      SecondsEnd=Seconds;
      if (BeepStateProcess) my_beep(BEEP_LONG);
    }
    break;
  case 101: // Превышение температуры в ТСА!!!
    my_beep(3*BEEP_LONG);
  case 100:// Конечное состояние автомата
    // Отключаем на всякий случай все!
    if (FlToGSM && lastSMSState!=StateMachine) StateToSMS();
    if (BeepEndProcess) my_beep(BEEP_LONG);
    UstPower=0;
    // Отключаем подчиненные
    digitalWrite(PIN_SLAVE_0, 0);
    digitalWrite(PIN_SLAVE_1, 0);
    digitalWrite(PIN_SLAVE_2, 0); 
    digitalWrite(PIN_SLAVE_3, 0);
    CloseAllKLP();
//    digitalWrite(PIN_REG_ON,LOW);
    digitalWrite(PIN_RZG_ON,!RELAY_HIGH);
    digitalWrite(PIN_ALL_OFF,ALL_OFF_HIGH);
    digitalWrite(PIN_START_1,!RELAY_HIGH);
    digitalWrite(PIN_START_2,!RELAY_HIGH);
    flAllOff=1;

    break;
  }

}

