void ScanDS18b20Slave()
{
  char maxDs;
  maxDs=0;
  // Первый этап-читаем датчики три раза.
  while (nPopr<3)
  {
    nPopr++;
    delay(1500);
    ds1820_devices=0;
    while(ds.search(ds1820_rom_codes[ds1820_devices])) {
      ds1820_devices++;
      if (ds1820_devices>=MAX_DS1820) break;
    }
    ds.reset_search();
    if (ds1820_devices>maxDs) maxDs=ds1820_devices;
    if (ds1820_devices>=3) return; 
  }
  // Если за время чтения количество датчиков больше 1,то читаем датчики еще 7 раз
  if (maxDs>0)
  {
     while (nPopr<10)
    {
      nPopr++;
      delay(1500);
      ds1820_devices=0;
      while(ds.search(ds1820_rom_codes[ds1820_devices])) {
        ds1820_devices++;
        if (ds1820_devices>=MAX_DS1820) break;
      }
      ds.reset_search();
      if (ds1820_devices>maxDs) maxDs=ds1820_devices;
      if (ds1820_devices>=3) return; 
    }    
  }
  
}

void RaspredPowerByPhase()
{
  #if NUM_PHASE==0
    if (PowerPhase[0]<=0) PowerPhase[0]=Power;
    // Корректировка мощности если установлено ограничение мощности по фазе
    if (UstPower>Power) UstPower=Power;
    UstPwrPH1=UstPower;  
  #else
    #if NUM_PHASE==1
        if (StateNPG<2) UstPower=0;
        if (UstPower>=Power) 
          UstPwrPH2=PowerPhase[1];
        else
        { if (PowerPhase[1]>10) UstPwrPH2=((((long)UstPower*PowerPhase[1])/100)*KtPhase[1])/Power;
            else UstPwrPH2=0;
        }
                    
        sprintf(my_tx_buffer,"W%04i/%04iH2#",UstPwrPH2,PowerPhase[1]); 
        
        Serial1.println(my_tx_buffer); 
        
        if (UstPower>=Power) 
          UstPwrPH3=PowerPhase[2];
        else
        { if (PowerPhase[2]>10) UstPwrPH3=((((long)UstPower*PowerPhase[2])/100)*KtPhase[2])/Power;
            else UstPwrPH3=0;
        }
             
        sprintf(my_tx_buffer,"W%04i/%04iH3#",UstPwrPH3,PowerPhase[2]); 
        Serial1.println(my_tx_buffer); 
        
        if (UstPower>=Power) UstPwrPH1=PowerPhase[0];
        else 
        { 
          if (PowerPhase[0]>10)  UstPwrPH1=((((long)UstPower*PowerPhase[0])/100)*KtPhase[0])/Power;
                            else UstPwrPH1=0;
        }
    #endif
  #endif
}


void ProcessSlavePhase()
{   
  char s_rx;

  while (Serial1.available() > 0)     
  {
    s_rx=Serial1.read();
      
      
      #ifdef TEST
          // Дублируем информацию на Serial1
          Serial.write(s_rx);
      #endif

      if (s_rx==10)
      {
        my_rx_buffer[pos_rx_buffer-1]=0;
        pos_rx_buffer=0;
        //Формат команды
        //"W1000/2000H1#" Где PW-Начальная строчка,1000 - установленная мощность, 2000 - номинальная мощность, H-номер фазы
          
        #ifdef TEST
          Serial.print("GetCommand:");
          Serial.println(my_rx_buffer);
        #endif

        if (strlen(my_rx_buffer)==13 && my_rx_buffer[12]=='#' &&  my_rx_buffer[0]=='W' && (my_rx_buffer[11]-48)==NUM_PHASE)
        {
          UstPower=int(my_rx_buffer[1]-48)*1000+int(my_rx_buffer[2]-48)*100+int(my_rx_buffer[3]-48)*10+int(my_rx_buffer[4]-48);
          Power=int(my_rx_buffer[6]-48)*1000+int(my_rx_buffer[7]-48)*100+int(my_rx_buffer[8]-48)*10+int(my_rx_buffer[9]-48);
          PowerPhase[0]=Power;
          PowerPhase[1]=0;
          PowerPhase[2]=0;
          UstPwrPH1=UstPower;
          UstPowerReg=UstPower;
          if (TekFraction==0)
          {
            KlOpen[KLP_SR]=(long)UstPower*100/Power;
            KlClose[KLP_SR]=KlOpen[KLP_SR];
          }
          else
          {
            KlOpen[KLP_SR]=0;
            KlClose[KLP_SR]=100;
          }
          TekFraction=!TekFraction;
        }

      }
      else
      {
        if (pos_rx_buffer>=MY_RX_BUFFER_SIZE) pos_rx_buffer=0;
        my_rx_buffer[pos_rx_buffer]=s_rx;
        pos_rx_buffer++;
        my_rx_buffer[pos_rx_buffer]=0;
      }
  }
  // Окончание анализа сотового  
  if (Seconds % 128==0)
  {
    // Раз в две минуты сбрасываем признак передачи
    KlOpen[KLP_SR]=0;
    KlClose[KLP_SR]=100;
  }
  
}


